package squidcache;

require 'util.pl';
use File::Basename;
use strict;

BEGIN {
}

sub mediatype()    {'application/x-squid-cache'; }
sub recursive()    {1; }
sub pre_codeconv() {0; }
sub post_codeconv(){0; }

sub status() {
    return 'yes';
}

# MagicEntryν狼SquidCacheƬΥХʥ꤬ʤΤ⤷...
sub add_magic ($) {
    my ($magic) = @_;
#    $_[0]->addMagicEntry('0 string HTTP/1 application/x-squid-cache'); 
    $magic->addFileExts('[0-9A-Z]{8}$', 'application/x-squid-cache');
}

sub _replacecode {
  my $filename = shift;
  
  my ($name, $path) = fileparse($filename);
  if (open(FILE, $filename)) {
      # get url allowed to squid cache file format
      # 60 byte skip, url end with '\x00"
      my $c = '';
      read(FILE, $c, 512 + 60);
      close(FILE);
      $filename = getsquidurl($c);
  } else {
      util::vprint("Can not open URL file: $filename\n");   
  }
  return $filename;
}

sub replacecode {
    $_ = _replacecode($_);
}

sub getsquidurl {
    my ($str) = @_;
    # 60byte ɤФ
    $str = substr($str, 60, 512); 
    # hǻϤޤ(http://... )\x00ǽʬURL
    $str =~ /^(h[^\x00]+)\x00/;
    $str = $1;
    $str;
}

# ǥåƤѹ뤿ΤΤ?
sub filter ($$$$$) {
    my ($orig_cfile, $contref, $weighted_str, $headings, $fields) = @_;
    util::vprint($$orig_cfile . "\n");
    #----- [url or data?] -----

    my $url = getsquidurl($$contref);
    if ($url =~ /^h/ && $$contref =~ s/^.*(\015\012\015\012|\n\n)//s) {
        util::vprint("Processing squid cache file ...\n");        
        #----- [delete http header] -----
        $$contref =~ s/^<!-- MHonArc v\d+\.\d+\.\d+ -->//;
    }
    else {
        $$contref = '';
    }
    return undef;  
}


1;
